<?php

/**
 * co_comite_evaluador actions.
 *
 * @package    contratacion
 * @subpackage co_comite_evaluador
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_comite_evaluadorActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_COMITE_EVALUADOR','CO_SELECCION_EP','CO_ESTUDIOS_PREVIOS','CO_MODALIDAD_SEL','CO_TIPO_EVALUADOR'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_SELECCION_EP' =>
         array (
            'id_seleccion_ep' => 'CO_COMITE_EVALUADOR'
         ),        
        'CO_ESTUDIOS_PREVIOS' =>
         array (
            'id_estudios_previos' => 'CO_SELECCION_EP'
         ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'CO_ESTUDIOS_PREVIOS'
        ),
        'CO_TIPO_EVALUADOR' => 
        array(
            'id_tipo_evaluador' => 'CO_COMITE_EVALUADOR'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_COMITE_EVALUADOR' =>
       array(
            'id_comite_evaluador' => 'id_comite_evaluador',
            'id_seleccion_ep' => 'id_seleccion_ep',
            'id_tipo_evaluador' => 'id_tipo_evaluador',
            'nombre_razon_evaluador' => 'nombre_razon_evaluador',
            'email' => 'email'
           
        ),
        'CO_SELECCION_EP' =>
        array(
            'fecha_inicio' => 'fecha_inicio',
            'estado' => 'estado'
        ),
        'CO_ESTUDIOS_PREVIOS'=>
        array(
            'no_proceso' => 'no_proceso',
            'id_anhos' => 'id_anhos',
            'fecha_creacion' => 'fecha_creacion'
        ),
        'CO_MODALIDAD_SEL'=>
        array(
          'descripcion' => 'descripcion_modalidad'  
        ),
        'CO_TIPO_EVALUADOR' =>
        array(
          'descripcion' => 'tipo_evaluador'  
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_COMITE_EVALUADOR' =>
        array(    
            'id_comite_evaluador,a' => array('!=' => array(-1)),
            'id_comite_evaluador,b' => array('=' => array('id_comite_evaluador')),
            'id_seleccion_ep' => array('=' => array('id_seleccion_ep')),
            'id_tipo_evaluador' => array('=' => array('id_tipo_evaluador')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_estudios_previos' => array('=' => array('id_estudios_previos')),
        )
        
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_comite_evaluador'; //identificador de la tabla
    protected $id_names = array('id_comite_evaluador'); //llave primaria
    protected $field_names = array('id_seleccion_ep','id_tipo_evaluador','nombre_razon_evaluador','email'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_COMITE_EVALUADOR'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_comite_evaluador'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            

        }

        //accion update
        if ($Action == "UPDATE") {
         
			$this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

		try {
            
             //ENVIO CORREO 5 - Notificaci�n comite evaluador
//PARAMETROS GENERALES

		$subject = "Notificacion de Comite Evaluador";
		//Email Envio
                if (!isset($request["email_envio"])) {
                    $request["email_envio"] = "modulocontratacion@sgc.gov.co";
                }
                $adjunto = false;
                $ruta = "";

                /*
                 * Variable Memcache
                 */
                $progress_key = $request['progress_key'] . $request['username'];
                $this->logMessage("Valor de progress_key: " . $progress_key);

                $array_adjuntos = array();


                $sql = "
        SELECT tab0.dia_sistema||' de '||tab0.mes_sistema||' del '||anho_sistema AS FECHA_SISTEMA
           from(
            select LPAD(to_char(sysdate,'dd'),2,'0') as dia_sistema,
            trim(initcap(to_char(sysdate,'MONTH','nls_date_language=spanish'))) as mes_sistema,
            TO_CHAR(sysdate,'yyyy') as anho_sistema
            from dual
        )tab0
        ";

                $records = CN_TABLE::executeSQL($sql);
                $fecha_creacion = $records[0]['fecha_sistema'];
			
		    $id_comite_evaluador = $request['id_comite_evaluador'];
			$sql = <<<EOD
	select tab2.id_estudios_previos,tab0.nombre_razon_evaluador as nombre, nvl(tab0.mail,'mesadeayuda@sgc.gov.co'),tab1.descripcion as tipo_evaluador
	from co_comite_evaluador tab0
	left join co_tipo_evaluador tab1 ON tab1.id_tipo_evaluador = tab0.id_tipo_evaluador
	left join co_seleccion_ep tab2 ON tab2.id_seleccion_ep = tab0.id_seleccion_ep

EOD;

            $records = CN_TABLE::executeSQL($sql);

		$email = $records[0]['email'];
		$nombre = $records[0]['nombre'];
		$tipo = $records[0]['tipo_evaluador'];
		$id_estudios_previos = $records[0]['id_estudios_previos'];

		$sql = <<<EOD
select tab0.* from co_estudios_previos_v tab0 where tab0.id_estudios_previos = $id_estudios_previos
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $responsable = $records[0]['nombre_responsable'];
            $area = $records[0]['area'];
            $valor = $records[0]['valor'];
            $valor = number_format($valor);
            $modalidad = $records[0]['modalidad'];
            $abogado = $records[0]['abogado'];
            $proceso = $records[0]['proceso'];
	    $objeto = $records[0]['objeto'];	
	    $documento = 1;
            $tipo_doc = 1;
            $nombre = $nombre;
            $email = $email;
           
		$parametros = $documento . ";$tipo_doc;" . $email . ";" . $nombre . ";Envio notificacion";

		 $datos_usuario = array();

                    if ($parametros != "") {
                        $datos_usuario = explode('/', $parametros);
                    }

//CUERPO DEL MENSAJE

                    $body = "<html><body> </body></html>";
//Body
                    $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/>
                Señor(a)<br/>
                $nombre<br/>
                <br/><br/>
                Por medio de la presente se notifica la asignacion como miembro del comite evaluador para el presente proceso:
                <b>Tipo Evaluador:</b> $tipo<br/><br/>
                <b>Proceso No.</b> $proceso<br/><br/>
                <b>Area:</b> $area<br/><br/>
                <b>Valor:</b> $valor <br/>
		<b>Responsable:</b> $responsable<br/><br/>
                <b>Abogado:</b> $abogado<br/><br/>
                <b>Objeto:</b> $objeto<br/><br/>
                <br/><br/>
                </body></html>
EOD;

                    $currentUri = "";

                    CN_TABLE::envioCorreo($request, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $body);
                

			

        } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
	   
		
	}
        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {
         /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest"); 
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }   
    
    private function htmlClear($string) {
        
        $string = str_replace('<p>', '<p align="justify">', $string);
        $string = str_replace('<br>', '<br/>', $string);
        $string = str_replace('class=', '', $string);
        $string = str_replace('<img', '', $string);
        $string = str_replace('<td>X</td>', '<td align="center">X</td>', $string);
        //$string = str_replace('<td align="top">', '<td align="justify">', $string);
        //$string = str_replace('<td align="justify">X</td>', '<td align="center">X</td>', $string);
        $string = str_replace('<td rowspan="2">', '<td rowspan="2" align="justify">', $string);

        $string = str_replace('<font size="2">', '<font size="10">', $string);
        $string = str_replace('<font size="3">', '<font size="12">', $string);
        $string = str_replace('<font size="4">', '<font size="14">', $string);
        $string = str_replace('<font size="5">', '<font size="18">', $string);
        $string = str_replace('<font size="6">', '<font size="24">', $string);
        $string = str_replace('<font size="7">', '<font size="36">', $string);
	$string = str_replace('<table ', '<center><table ', $string);
        $string = str_replace('</table> ', '</table></center>', $string);
        $string = str_replace('<table ', '<table border="1"', $string);
        
        $string = str_replace('size="2"', 'size="10"', $string);
        $string = str_replace('size="3"', 'size="12"', $string);
        $string = str_replace('size="4"', 'size="14"', $string);
        $string = str_replace('size="5"', 'size="18"', $string);
        $string = str_replace('size="6"', 'size="24"', $string);
        $string = str_replace('size="7"', 'size="36"', $string);

	$string = str_replace('border="0"', 'border="1"', $string);
        
        
        $string = str_replace('<div>', '<div align="justify">', $string);
	$string = str_replace('&amp;amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;nbsp;', '', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;nbsp;', '', $string);
        $string = str_replace('<style type="text/css">P { margin-bottom: 0.08in; direction: ltr; color: rgb(0, 0, 0); line-height: 100%; text-align: justify; widows: 2; orphans: 2; }P.western { font-family: "Tahoma",sans-serif; font-size: 11pt; }P.cjk { font-family: "Times New Roman",serif; font-size: 11pt; }P.ctl { font-family: "Tahoma",sans-serif; font-size: 11pt; }A:link { color: rgb(0, 0, 255); }</style>', ' ', $string);

        $string = str_replace('<td colspan="2">', '<td colspan="2" align="justify">', $string);
        $string = str_replace('<td rowspan="3">', '<td rowspan="3" align="justify">', $string);
        $string = str_replace('<td colspan="3">', '<td colspan="3" align="justify">', $string);
        $string = str_replace('<td rowspan="4">', '<td rowspan="4" align="justify">', $string);
        $string = str_replace('<td colspan="4">', '<td colspan="4" align="justify">', $string);
        $string = str_replace('  ', ' ', $string);
        $string = str_replace('   ', ' ', $string);
        $string = str_replace('    ', ' ', $string);
        $string = str_replace('	    ', ' ', $string);
        $string = str_replace('		    ', ' ', $string);
        //$string = str_replace('<span lang="ES-TRAD">', '<span>', $string);
        $string = str_replace('<span lang="ES-COL">', '<span>', $string);
        $string = str_replace('<!-- @page { size: 21cm 29.7cm; margin: 2cm } P { margin-bottom: 0.21cm } -->', '', $string);
        $string = str_replace('<p lang="es-MX" align="justify">', '', $string);
        //$string = str_replace('<span>', '', $string);
        //$string = str_replace('</span>', '', $string); #Este es el que MAS jode :::::::::::::::::
        $string = str_replace('valign', 'align', $string);
        ;
        $string = str_replace('width=', '', $string);
        //    $string = str_replace('&nbsp;', '', $string);
        //      $string = str_replace('cellspacing=', '', $string);
        //      $string = str_replace('cellpadding=', '', $string);
        $string = str_replace('bordercolor=', '', $string);
        $string = str_replace('<td>', '<td align="justify">', $string);
        $string = str_replace('<li>', '<li align="justify">', $string);
        $string = str_replace('style=', '', $string);
	$string = str_replace('<br clear="all">', '', $string);
        return trim($string);
    }
    
}
